package com.unipi.talepis.protal2021_3;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.location.Location;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.AuthResult;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;

import java.util.Arrays;
import java.util.List;

public class MainActivity extends AppCompatActivity {
    FirebaseDatabase database;
    DatabaseReference myRef;
    EditText editText;
    TextView textView;
    private FirebaseAuth mAuth;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        database = FirebaseDatabase.getInstance();
        myRef = database.getReference("message");
        mAuth = FirebaseAuth.getInstance();
        editText = findViewById(R.id.editTextTextPersonName);
        textView = findViewById(R.id.textView);
    }
    public void writeDB(View view){
        /*DatabaseReference studentRef = database.getReference("Student");
        Student s1 = new Student("Georgios","MPPL2021567",25);
        studentRef.setValue(s1);*/
        List<Student> students = Arrays.asList(new Student("Dimitris","ghjk",22),
                new Student("Stavros","hg54",32),
                new Student("Kwnstantina","rt4567",27));
        DatabaseReference studentlistRef = database.getReference("Students");
        studentlistRef.setValue(students);
        //myRef.child("somethingelse").setValue("Hello!");
        /*myRef.push().setValue("Dimitrios");
        myRef.push().setValue("Iliana");*/
        /*myRef.setValue(editText.getText().toString())
                .addOnCompleteListener(new OnCompleteListener<Void>() {
                    @Override
                    public void onComplete(@NonNull Task<Void> task) {
                        if (task.isSuccessful())
                            Toast.makeText(getApplicationContext(),
                                    "Inserted!",Toast.LENGTH_LONG).show();
                        else
                            Toast.makeText(getApplicationContext(),task.getException().toString(),
                                    Toast.LENGTH_LONG).show();
                    }
                });*/
    }
    public void readdb(View view){
        /*myRef.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(@NonNull DataSnapshot snapshot) {
                String message = snapshot.getValue(String.class);
                textView.setText(textView.getText().toString()+
                        "\n"+message);
            }

            @Override
            public void onCancelled(@NonNull DatabaseError error) {

            }
        });*/
        DatabaseReference listRef = database.getReference("Students");
        Query query = listRef.orderByChild("name").equalTo("Stavros");
        query.addListenerForSingleValueEvent(new ValueEventListener() {
            @Override
            public void onDataChange(@NonNull DataSnapshot snapshot) {
                textView.setText(snapshot.getValue().toString());
            }

            @Override
            public void onCancelled(@NonNull DatabaseError error) {

            }
        });
    }
    public void signin(View view){
        mAuth.signInWithEmailAndPassword("talepis@unipi.gr","123456")
                .addOnCompleteListener(new OnCompleteListener<AuthResult>() {
                    @Override
                    public void onComplete(@NonNull Task<AuthResult> task) {
                        if (task.isSuccessful()){
                            textView.setText("User is authenticated\n"+
                                    mAuth.getUid());

                        }else {
                            textView.setText(task.getException().getLocalizedMessage());
                        }
                    }
                });
        //mAuth.signOut();
    }
    public void signup(View view){
        mAuth.createUserWithEmailAndPassword("john@yahoo.com","123456")
                .addOnCompleteListener(new OnCompleteListener<AuthResult>() {
                    @Override
                    public void onComplete(@NonNull Task<AuthResult> task) {
                        if (task.isSuccessful()){
                            textView.setText("User is authenticated\n"+
                                    mAuth.getUid());

                        }else {
                            textView.setText(task.getException().getLocalizedMessage());
                        }
                    }
                });
    }
    public void map(View view){
        startActivity(new Intent(this,MapsActivity.class));
        Location myLocation = new Location("Piraeus");
        myLocation.setLatitude(35.46465456);
        myLocation.setLongitude(24.456789);
        Location otherLocation = new Location("allou");
        myLocation.setLatitude(35.46465111);
        myLocation.setLongitude(24.456222);
        float distance = myLocation.distanceTo(otherLocation);
        Toast.makeText(getApplicationContext(),String.valueOf(distance),Toast.LENGTH_LONG).show();
    }
}